#ifndef CHESSY_CHESSGAME_H
#define CHESSY_CHESSGAME_H

#include <vector>

#include "Board.h"

namespace chessy
{
    class ChessGame;
}


class chessy::ChessGame
{
    Board board;

    bool canCastleQueenSideWhite =  true;
    bool canCastleQueenSideBlack =  true;
    bool canCastleKingSideWhite =   true;
    bool canCastleKingSideBlack =   true;

    short reversibleHalfMoves =     0;

    Index enPassantWhite =          -1;
    Index enPassantBlack =          -1;

public:
    ChessGame(void) = default;
    ChessGame(const ChessGame&) = default;
    ~ChessGame(void) = default;

    bool isValidMove(const Move& move) const;
    std::vector<Move> getValidMoves(void) const;
};

#endif // CHESSY_CHESSGAME_H

